/*
 * author: Darren Bounds <dbounds@intrusense.com>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * packit official page at http://packit.sourceforge.net
 */

#include <time.h>

#include "../include/packit.h"
#include "../include/capture.h"
#include "../include/error.h"

#define TIMESTAMP_BUF_MAX 	64

void 
print_timestamp(struct pcap_pkthdr *pkthdr)
{
    char timestamp[TIMESTAMP_BUF_MAX];

    struct tm *ltm;
    struct timeval tv;
    struct timeval *tvp;

#ifdef __DEBUG
    fprintf(stderr, "DEBUG: Displaying timestamp\n");
#endif

    if(time_gmt)
    {
        snprintf(timestamp, TIMESTAMP_BUF_MAX, "%02ld:%02ld:%02ld.%06u",
            (pkthdr->ts.tv_sec % 86400) / 3600,
	    ((pkthdr->ts.tv_sec % 86400) % 3600) / 60,
            (pkthdr->ts.tv_sec % 86400) % 40,
            (unsigned int)pkthdr->ts.tv_usec);
    }
    else
    {
        bzero(&tv, sizeof(tv));
        bzero(&ltm, sizeof(ltm));

	tvp = &tv;

        gettimeofday(tvp, NULL);
        ltm = localtime((time_t *) & tvp->tv_sec);

        snprintf(timestamp, TIMESTAMP_BUF_MAX, "%02ld:%02ld:%02ld.%06lu",
	    (unsigned long)ltm->tm_hour,
	    (unsigned long)ltm->tm_min,
	    (unsigned long)ltm->tm_sec,
	    (unsigned long)pkthdr->ts.tv_usec);
    }

    fprintf(stdout, "Timestamp:   %s\n", timestamp);

    return;
}
